;Pilote (bibliothque dynamique) pour conductimtre Chauvin-Arnoux (Heito) C320
; logiciel libre // libera programaro // free software
; Copyright (C) 2017 Pierre Dieumegard (pierre.dieumegard@free.fr)
;   http://sciencexp.free.fr
; (exemples de programmes d'application de la famille Mensurasoft)
;
;Ce logiciel est un logiciel libre au sens LGPL3 (http://www.gnu.org/licenses/lgpl.txt)


;Tous droits rservs.

;Cette bibliothque est un logiciel libre ; vous pouvez la redistribuer ou
;la modifier suivant les termes de la Licence Gnrale Publique Limite
;GNU telle que publie par la Free Software Foundation ; soit la
;version 3 de la License, soit ( votre gr) toute version ultrieure.
;Cette bibliothque est distribue dans lespoir quelle sera utile, mais
;SANS AUCUNE GARANTIE : sans mme la garantie implicite de
;COMMERCIALISABILIT ou dADQUATION  UN OBJECTIF PARTICULIER. Consultez
;la Licence Gnrale Publique Limite pour plus de dtails.
;Vous devriez avoir reu une copie de la Licence Gnrale Publique Limite
;GNU avec cette bibliothque ; si ce nest pas le cas, crivez  la :
;Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
;MA 02110-1301, USA.

;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU Lesser General Public
; License As published by the Free Software Foundation; either
; version 2.1 of the License, Or (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE. See the GNU
; Lesser General Public License For more details.
; 
; You should have received a copy of the GNU Lesser General Public
; License along With this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
Global bavard.i = 0  ; 1 => crit les dtails ; 0 ==> n'crit pas les dtails dans la console
Global port$
Global nea$
Global nead$
Global nsa$
Global nsad$
Global neb$
Global nsb$
Global chglob$ = ""
Global chainemesures$
Global memodate=0

Global memosa .w
Global memosad .d
Global Dim memosb .w (8)

Global titre$
Global unite$=" g"
Global memochaine$="0"
Global detail$
Global wretour .w
Global dretour .d



Procedure miseajour(parameter);
buffer.b=0
text$=""
Repeat
  WriteSerialPortString(0,"G")
  Delay(3000);
  ReadSerialPortData(0,@buffer,1)
  text$=Chr(buffer)
  While AvailableSerialPortInput(0)>0
    If ReadSerialPortData(0,@buffer,1)
      text$=text$+Chr(buffer) 
    EndIf 
    ch$=text$
  Wend
  ; If bavard=1 : Numascii=Asc(Mid(ch$,Len(ch$)-3)) :    PrintN(ch$+"  // "+Str(numascii)):      EndIf 
  If bavard=1 :    PrintN(ch$):      EndIf 
  chainemesures$=ch$
ForEver 
EndProcedure



Procedure .s portdisponible() 
  Global port$
  chloc$=""
         Select #PB_Compiler_OS 
        Case #PB_OS_Windows
             OpenConsole() :       PrintN("Test des ports COM 1..20 : (30 secondes...)")
          baseport$="Com" :          numdepart=1
          For i=numdepart To 20    
            resultat= OpenSerialPort( #PB_Any, baseport$+StrU(i), 2400, #PB_SerialPort_NoParity, 8, 2, #PB_SerialPort_NoHandshake, 1024, 1024)
            If resultat >0
              ch$="" :       chloc$=chloc$+"|"+baseport$+StrU(i) :         PrintN("* "+baseport$+StrU(i)+ " ?")
              WriteSerialPortString(resultat,"G") :          Delay(2000) :       ReadSerialPortData(resultat,@buffer,1)
              text$=Chr(buffer)
              While AvailableSerialPortInput(resultat)>0
                If ReadSerialPortData(resultat,@buffer,1) :     text$=text$+Chr(buffer) :      EndIf 
                ch$=text$
              Wend
              If (Len(ch$)>7)And(FindString(ch$,"S")> 0)And(FindString(ch$,"degre")>0)
                PrintN("********* conductimtre en Com"+StrU(i))
                port$="Com"+StrU(i)
                EndIf 
          CloseSerialPort(resultat)
        EndIf
      Next i
                CloseConsole() ; fin de windows
              Case #PB_OS_Linux
                     OpenConsole()
          PrintN("Test des ports /dev/ttyS, /dev/ttyUSB, /dev/ttyACM : (30 secondes...)")
           baseport$="/dev/ttyS" :     numdepart=0
             For i=numdepart To 5    
                resultat= OpenSerialPort( #PB_Any, baseport$+StrU(i),38400,#PB_SerialPort_EvenParity, 8, 1, #PB_SerialPort_NoHandshake, 1024, 1024)
                    If resultat >0
                      chloc$=chloc$+"|"+baseport$+StrU(i):     
                         Port$=baseport$+StrU(i)
;                       PrintN("* "+baseport$+StrU(i)+ " ?")
;                        WriteSerialPortString(resultat,"G") :          Delay(2000) :       ReadSerialPortData(resultat,@buffer,1)
;               text$=Chr(buffer)
;               While AvailableSerialPortInput(resultat)>0
;                 If ReadSerialPortData(resultat,@buffer,1) :     text$=text$+Chr(buffer) :      EndIf 
;                 ch$=text$
;               Wend
;               If (Len(ch$)>7)And(FindString(ch$,"S")> 0)And(FindString(ch$,"degre")>0)
;                 PrintN("********* conductimtre en "+baseport$+StrU(i))
;                 port$=baseport$+StrU(i)
;                 EndIf 
              CloseSerialPort(resultat)
                    EndIf
                  Next
             baseport$="/dev/ttyUSB"
             numdepart=0
             For i=numdepart To 5   
                resultat= OpenSerialPort( #PB_Any, baseport$+StrU(i),38400,#PB_SerialPort_EvenParity, 8, 1, #PB_SerialPort_NoHandshake, 1024, 1024)
                    If resultat >0
                      chloc$=chloc$+"|"+baseport$+StrU(i): 
                      Port$=baseport$+StrU(i)
;                       PrintN("* "+baseport$+StrU(i)+ " ?")
;                        WriteSerialPortString(resultat,"G") :          Delay(2000) :       ReadSerialPortData(resultat,@buffer,1)
;               text$=Chr(buffer)
;               While AvailableSerialPortInput(resultat)>0
;                 If ReadSerialPortData(resultat,@buffer,1) :     text$=text$+Chr(buffer) :      EndIf 
;                 ch$=text$
;               Wend
;               If (Len(ch$)>7)And(FindString(ch$,"S")> 0)And(FindString(ch$,"degre")>0)
;                 PrintN("********* conductimtre en "+baseport$+StrU(i))
;                 port$=baseport$+StrU(i)
;                 EndIf 
              CloseSerialPort(resultat)
                    EndIf
                  Next
                   baseport$="/dev/ttyACM"
             numdepart=0
             For i=numdepart To 5    
                resultat= OpenSerialPort( #PB_Any, baseport$+StrU(i),38400, #PB_SerialPort_EvenParity, 8, 1, #PB_SerialPort_NoHandshake, 1024, 1024)
                    If resultat >0
                      chloc$=chloc$+"|"+baseport$+StrU(i) :  
                         Port$=baseport$+StrU(i)
;                       PrintN("* "+baseport$+StrU(i)+ " ?")
;                        WriteSerialPortString(resultat,"G") :          Delay(2000) :       ReadSerialPortData(resultat,@buffer,1)
;               text$=Chr(buffer)
;               While AvailableSerialPortInput(resultat)>0
;                 If ReadSerialPortData(resultat,@buffer,1) :     text$=text$+Chr(buffer) :      EndIf 
;                 ch$=text$
;               Wend
;               If (Len(ch$)>7)And(FindString(ch$,"S")> 0)And(FindString(ch$,"degre")>0)
;                 PrintN("********* conductimtre en "+baseport$+StrU(i))
;                 port$=baseport$+StrU(i)
;                 EndIf 
              CloseSerialPort(resultat)
                    EndIf
                  Next i
                  CloseConsole()
          EndSelect
 
 
 ProcedureReturn(chloc$)
EndProcedure  

 

ProcedureDLL .d ead(n .w)
  chloc$=chainemesures$
    coeff.d=1
  Select n
    Case 0 :coef =1
      If FindString(chloc$,"mS")>0:coeff=1000:EndIf 
      If FindString(chloc$," S")>0:coeff=1000:EndIf
      If FindString(chloc$,Chr(129)+"S")>0:coeff=1:EndIf 
      If FindString(chloc$,"nS")>0:coeff=0.001:EndIf 
      chloc$=Mid(chloc$,1,5)
    Case 1 : chloc$=chainemesures$:chloc$=Mid(chloc$,10,6)
  EndSelect

ProcedureReturn(ValD(chloc$)*coeff)
EndProcedure


ProcedureDLL .s nead(n .w)
Select n
  Case 0 :    nead$="Conduct. microS/cm"
  Case 1 : nead$="T deg.C"

   Default 
    nead$=""
    EndSelect
ProcedureReturn(nead$)
EndProcedure

ProcedureDLL .w ea(n .w)
  valretour=999
  Select n 
  Case 0 :valretour=Round(ead(n)*100, #PB_Round_Nearest)
  Case 1 :  valretour=Round(ead(n)*10, #PB_Round_Nearest)
    EndSelect 
ProcedureReturn(valretour)
EndProcedure

ProcedureDLL .s nea (n .w)
  Select n
  Case 0 :    nea$="Conductivit nS"
  Case 1:    nea$="T C*10"

   Default 
    nea$=""
  EndSelect
ProcedureReturn(nea$)
EndProcedure

ProcedureDLL .w sa(n .w , valeur .w)
ProcedureReturn(-777)
  
memosa=valeur
ProcedureReturn (valeur)
EndProcedure



ProcedureDLL .s nsa (n .w)

  nsa$=""
  ProcedureReturn(nsa$)
EndProcedure

ProcedureDLL .w rsa(n .w)
ProcedureReturn(memosa)
EndProcedure


ProcedureDLL .d sad (n .w , valeur .d)
valeur=-777
memosad=valeur
ProcedureReturn(valeur)
EndProcedure

ProcedureDLL .s nsad (n .w)
   nsad$=""
   ProcedureReturn(nsad$)
EndProcedure

ProcedureDLL .d rsad(n .w)
ProcedureReturn(memosad)
EndProcedure

ProcedureDLL .w eb (n .w)
ProcedureReturn(-777)
EndProcedure

ProcedureDLL .s neb (n .w)
    neb$=""
   ProcedureReturn neb$
EndProcedure

ProcedureDLL .w sb(n .w , valeur .w)
   memosb(n)=valeur
   ProcedureReturn(-777)
EndProcedure

ProcedureDLL .s nsb(n .w)
   nsb$=""
 ProcedureReturn(nsb$)
EndProcedure

ProcedureDLL .w rsb(n .w)
ProcedureReturn(memosb(n))
EndProcedure



ProcedureDLL .s titre()
titre$="conductimtre Chauvin-Arnoux C320"
ProcedureReturn(titre$)
EndProcedure 


ProcedureDLL.s detail()
detail$="conductimtre Chauvin-Arnoux C320, P. Dieumegard, 3 mars 2017"
ProcedureReturn(detail$)
EndProcedure

ProcedureDLL .w stdea(n .w)
ProcedureReturn(ea(n))
EndProcedure

ProcedureDLL .s stdnea(n .w)
ProcedureReturn (nea(n))
EndProcedure



ProcedureDLL .d stdead(n .w)
;ProcedureReturn(n*1.1)
ProcedureReturn(ead(n))
EndProcedure

ProcedureDLL .s stdnead(n .w)
ProcedureReturn(nead(n))
 EndProcedure
 
 
ProcedureDLL .w stdsa(n .w , valeur .w)
ProcedureReturn(sa(n,valeur))
EndProcedure

ProcedureDLL .s stdnsa(n .w)
ProcedureReturn(nsa(n))
EndProcedure

ProcedureDLL .w stdrsa(n .w)
ProcedureReturn (rsa(n))
EndProcedure

ProcedureDLL .d stdsad(n .w , valeur .d)
ProcedureReturn(sad(n,valeur))
EndProcedure
 
 ProcedureDLL .s stdnsad(n .w)
 ProcedureReturn(nsad(n))
 EndProcedure
 
 ProcedureDLL .d stdrsad(n .w)
ProcedureReturn(rsad(n))
EndProcedure

ProcedureDLL .w stdeb(n .w)
ProcedureReturn(eb(n))
EndProcedure

ProcedureDLL .s stdneb(n .w)
ProcedureReturn (neb(n))
EndProcedure

ProcedureDLL .w stdsb(n .w , etat .w)
ProcedureReturn(sb(n,etat))
EndProcedure

ProcedureDLL .s stdnsb(n .w)
ProcedureReturn(nsb(n))
EndProcedure

ProcedureDLL .w stdrsb(n .w)
ProcedureReturn(rsb(n))
EndProcedure

 
 
 
 
 ProcedureDLL .s stdtitre()
   titre$=titre()
   ProcedureReturn(titre$)
 EndProcedure
 
 ProcedureDLL .s stddetail()
 detail$=detail()
 ProcedureReturn (detail$)
 EndProcedure
 
 ProcedureDLL .d eadouble(x .d)
 ProcedureReturn(ead(Round(x, #PB_Round_Nearest)))
 EndProcedure
 
 ProcedureDLL .s neadouble(x .d)
 ProcedureReturn(nead(Round(x, #PB_Round_Nearest)))
 EndProcedure
 
 
 
 ProcedureDLL .d sadouble(n .d , valeur .d)
 ProcedureReturn(sad(Round(n, #PB_Round_Nearest),valeur))
 EndProcedure
 
 ProcedureDLL .s nsadouble(n .d)
 ProcedureReturn nsad(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .d rsadouble(n .d)
 ProcedureReturn rsad(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .d ebdouble(n .d)
 ProcedureReturn eb(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .s nebdouble(n .d)
 ProcedureReturn neb(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .d sbdouble(n .d , valeur .d)
 ProcedureReturn sb(Round(n, #PB_Round_Nearest),Round(valeur, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .s nsbdouble(n .d)
 ProcedureReturn nsb(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .d rsbdouble(n .d)
 ProcedureReturn rsb(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .d stdeadouble(n .d)
 ProcedureReturn ead(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .s stdneadouble(n .d)
 ProcedureReturn neadouble(n)
 EndProcedure
 
 ProcedureDLL .d stdsadouble(n .d , valeur .d)
 ProcedureReturn sadouble(n,valeur)
 EndProcedure
 
 ProcedureDLL .s stdnsadouble(n .d)
 ProcedureReturn nsadouble(n)
 EndProcedure
 
 ProcedureDLL .d stdrsadouble(n .d)
 ProcedureReturn rsadouble(n)
 EndProcedure
 
  ProcedureDLL .d stdebdouble(n .d)
  ProcedureReturn ebdouble(n)
  EndProcedure
  
  ProcedureDLL .s stdnebdouble(n .d)
  ProcedureReturn nebdouble(n)
  EndProcedure
  
  ProcedureDLL .d stdsbdouble(n .d, valeur .d)
  ProcedureReturn sbdouble(n,valeur)
  EndProcedure
  
  ProcedureDLL .s stdnsbdouble(n .d)
  ProcedureReturn nsbdouble(n)
  EndProcedure
  
  ProcedureDLL .d stdrsbdouble(n .d)
  ProcedureReturn rsbdouble(n)
  EndProcedure
  
  
  ProcedureDLL .s stdeadstr(n .s)
    ProcedureReturn StrF(stdead(ValF(n)))
  EndProcedure 
  
  ProcedureDLL .s stdneadstr(n .s)
    ProcedureReturn stdnead(ValF(n))
  EndProcedure 
  
  ProcedureDLL .s stdsadstr(n .s, valeur .s)
    ProcedureReturn StrF(stdsad(ValF(n),ValF(valeur)))
  EndProcedure
  
  ProcedureDLL .s stdnsadstr(n .s)
    ProcedureReturn stdnsad(ValF(n))
    EndProcedure
  
  ProcedureDLL .s stdebstr(n .s)
    ProcedureReturn StrF(stdeb(Val (n)))
  EndProcedure
  
  ProcedureDLL .s stdnebstr(n .s)
    ProcedureReturn neb(Val(n))
  EndProcedure
  
  ProcedureDLL .s stdsbstr(n .s , valeur .s)
    ProcedureReturn Str(sb(Val(n),Val(valeur)))
  EndProcedure
  
  ProcedureDLL .s stdnsbstr(n .s)
    ProcedureReturn nsb(Val(n))
  EndProcedure
  
  ; fonctions cdecl surtout pour Linux

ProcedureCDLL .i cea(n .i)
ProcedureReturn(ea(n))
EndProcedure

ProcedureCDLL .s cnea(n .i)
ProcedureReturn (nea(n))
EndProcedure



ProcedureCDLL .d cead(n .i)
;ProcedureReturn(n*1.1)
ProcedureReturn(ead(n))
EndProcedure

ProcedureCDLL .s cnead(n .i)
;If n=0 
 ; ProcedureReturn ("entre an. 0")
  ;Else
  ;ProcedureReturn("")
;  EndIf  
ProcedureReturn(nead(n))
 EndProcedure
 
 
ProcedureCDLL .i csa(n .i , valeur .i)
ProcedureReturn(sa(n,valeur))
EndProcedure

ProcedureCDLL .s cnsa(n .i)
ProcedureReturn(nsa(n))
EndProcedure

ProcedureCDLL .i crsa(n .i)
ProcedureReturn (rsa(n))
EndProcedure

ProcedureCDLL .d csad(n .i , valeur .d)
ProcedureReturn(sad(n,valeur))
EndProcedure
 
 ProcedureCDLL .s cnsad(n .i)
 ProcedureReturn(nsad(n))
 EndProcedure
 
 ProcedureCDLL .d crsad(n .i)
ProcedureReturn(rsad(n))
EndProcedure

ProcedureCDLL .i ceb(n .i)
ProcedureReturn(eb(n))
EndProcedure

ProcedureCDLL .s cneb(n .i)
ProcedureReturn (neb(n))
EndProcedure

ProcedureCDLL .i csb(n .i , etat .i)
ProcedureReturn(sb(n,etat))
EndProcedure

ProcedureCDLL .s cnsb(n .i)
ProcedureReturn(nsb(n))
EndProcedure

ProcedureCDLL .i crsb(n .i)
ProcedureReturn(rsb(n))
EndProcedure

 
 
 
 
 ProcedureCDLL .s ctitre()
 titre$="titre dll"
 ProcedureReturn(titre$)
 EndProcedure
 
 ProcedureCDLL .s cdetail()
 detail$="dtail de la dll fictive"
 ProcedureReturn (detail$)
 EndProcedure
 
;  ProcedureCDLL .s ccalibration(ch .s)
;    ProcedureReturn(calibration(ch))
;  EndProcedure
;  
 
 ProcedureCDLL .d ceadouble(n .d)
 ProcedureReturn ead(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureCDLL .s cneadouble(n .d)
 ProcedureReturn neadouble(n)
 EndProcedure
 
 ProcedureCDLL .d csadouble(n .d , valeur .d)
 ProcedureReturn sadouble(n,valeur)
 EndProcedure
 
 ProcedureCDLL .s cnsadouble(n .d)
 ProcedureReturn nsadouble(n)
 EndProcedure
 
 ProcedureCDLL .d crsadouble(n .d)
 ProcedureReturn rsadouble(n)
 EndProcedure
 
  ProcedureCDLL .d cebdouble(n .d)
  ProcedureReturn ebdouble(n)
  EndProcedure
  
  ProcedureCDLL .s cnebdouble(n .d)
  ProcedureReturn nebdouble(n)
  EndProcedure
  
  ProcedureCDLL .d csbdouble(n .d, valeur .d)
  ProcedureReturn sbdouble(n,valeur)
  EndProcedure
  
  ProcedureCDLL .s cnsbdouble(n .d)
  ProcedureReturn nsbdouble(n)
  EndProcedure
  
  ProcedureCDLL .d crsbdouble(n .d)
  ProcedureReturn rsbdouble(n)
  EndProcedure
  
   ProcedureCDLL .s ceadstr(n .s)
    ProcedureReturn StrF(stdead(ValF(n)))
  EndProcedure 
  
    ProcedureCDLL .s cneadstr(n .s)
    ProcedureReturn stdnead(ValF(n))
  EndProcedure 
  
  
  ProcedureCDLL .s csadstr(n .s, valeur .s)
    ProcedureReturn StrF(stdsad(ValF(n),ValF(valeur)))
  EndProcedure
  
  ProcedureCDLL .s cnsadstr(n .s)
    ProcedureReturn stdnsad(ValF(n))
    EndProcedure
  
  ProcedureCDLL .s cebstr(n .s)
    ProcedureReturn StrF(stdeb(Val (n)))
  EndProcedure
  
  ProcedureCDLL .s cnebstr(n .s)
    ProcedureReturn neb(Val(n))
  EndProcedure
  
  ProcedureCDLL .s csbstr(n .s , valeur .s)
    ProcedureReturn Str(sb(Val(n),Val(valeur)))
  EndProcedure
  
  ProcedureCDLL .s cnsbstr(n .s)
    ProcedureReturn nsb(Val(n))
  EndProcedure
  
  ; fonctions de nommage numriques
  ProcedureDLL .l stdneadnum(n.i, pos.i):chloc$=stdnead(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):  EndProcedure 
  ProcedureDLL .l stdnsadnum(n.i,pos.i):chloc$=stdnsad(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureDLL .l stdnebnum(n.i,pos.i):chloc$=stdneb(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureDLL .l stdnsbnum(n.i,pos.i):chloc$=stdnsb(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureDLL .l stddetailnum(pos .i):chloc$=stddetail():ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure 
  ProcedureDLL .l stdtitrenum(pos.i):chloc$=stdtitre():ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  
  ProcedureCDLL .l cneadnum(n.i, pos.i):chloc$=cnead(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):  EndProcedure 
  ProcedureCDLL .l cnsadnum(n.i,pos.i):chloc$=cnsad(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureCDLL .l cnebnum(n.i,pos.i):chloc$=cneb(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureCDLL .l cnsbnum(n.i,pos.i):chloc$=cnsb(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureCDLL .l cdetailnum(pos .i):chloc$=cdetail():ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure 
  ProcedureCDLL .l ctitrenum(pos.i):chloc$=ctitre():ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
    
     ProcedureDLL .l stdneadoublenum(n.i, pos.i):chloc$=stdneadouble(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):  EndProcedure 
  ProcedureDLL .l stdnsadoublenum(n.i,pos.i):chloc$=stdnsadouble(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureDLL .l stdnebdoublenum(n.i,pos.i):chloc$=stdnebdouble(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureDLL .l stdnsbdoublenum(n.i,pos.i):chloc$=stdnsbdouble(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureDLL .l stddetaildoublenum(pos .i):chloc$=stddetail():ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure 
  ProcedureDLL .l stdtitredoublenum(pos.i):chloc$=stdtitre():ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  
  ProcedureCDLL .l cneadoublenum(n.i, pos.i):chloc$=cneadouble(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):  EndProcedure 
  ProcedureCDLL .l cnsadoublenum(n.i,pos.i):chloc$=cnsadouble(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureCDLL .l cnebdoublenum(n.i,pos.i):chloc$=cnebdouble(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureCDLL .l cnsbdoublenum(n.i,pos.i):chloc$=cnsbdouble(n):ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
  ProcedureCDLL .l cdetaildoublenum(pos .i):chloc$=cdetail():ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure 
  ProcedureCDLL .l ctitredoublenum(pos.i):chloc$=ctitre():ProcedureReturn Asc(Mid(chloc$,pos+1,1)):EndProcedure
    
    ;fonctions  paramtres passs par rfrence, 
  ProcedureDLL.d stdeadref(*n.INTEGER,*x.DOUBLE):rloc.d =stdead(*n\i):*x\d=rloc:ProcedureReturn(rloc): EndProcedure
  ProcedureDLL.s stdneadref(*n.INTEGER,*ch.STRING):rloc.s=stdnead(*n\i):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure 
  ProcedureDLL.d stdsadref(*n.INTEGER,*valeur.DOUBLE):afixer.d=*valeur:rloc.d=stdsad(*n\i,afixer):*valeur\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.s stdnsadref(*n.INTEGER,*ch.STRING):rloc.s=stdnsad(*n\i):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.i stdebref(*n.INTEGER,*res.INTEGER):rloc.i=stdeb(*n\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.s stdnebref(*n.INTEGER,*ch.STRING):rloc.s=stdneb(*n\i):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.i stdsbref(*n.INTEGER,*valeur.INTEGER):afixer.i=*valeur:rloc=stdsb(*n\i,*valeur\i):*valeur\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.s stdnsbref(*n.INTEGER,*ch.STRING):rloc.s=stdnsb(*n\i):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.s stddetailref(*ch.STRING):*ch\s=stddetail():ProcedureReturn(stddetail()):EndProcedure
  ProcedureDLL.s stdtitreref(*ch.STRING):*ch\s=stdtitre():ProcedureReturn(stdtitre()):EndProcedure
  
  
  ProcedureCDLL.d ceadref(*n.INTEGER,*x.DOUBLE):rloc.d =cead(*n\i):*x\d=rloc:ProcedureReturn(rloc): EndProcedure
  ProcedureCDLL.s cneadref(*n.INTEGER,*ch.STRING):rloc.s=cnead(*n\i):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure 
  ProcedureCDLL.d csadref(*n.INTEGER,*valeur.DOUBLE):afixer.d=*valeur:rloc.d=csad(*n\i,afixer):*valeur\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.s cnsadref(*n.INTEGER,*ch.STRING):rloc.s=cnsad(*n\i):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.i cebref(*n.INTEGER,*res.INTEGER):rloc.i=ceb(*n\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.s cnebref(*n.INTEGER,*ch.STRING):rloc.s=cneb(*n\i):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.i csbref(*n.INTEGER,*valeur.INTEGER):afixer.i=*valeur:rloc=csb(*n\i,*valeur\i):*valeur\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.s cnsbref(*n.INTEGER,*ch.STRING):rloc.s=cnsb(*n\i):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.s cdetailref(*ch.STRING):rloc.s="blabla":*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.s ctitreref(*ch.STRING):*ch\s=ctitre():ProcedureReturn(ctitre()):EndProcedure
  
  
  
  
; ProcedureDLL.d stdeadref(*n.INTEGER,*x.DOUBLE):rloc.d =stdead(*n\i):*x\d=rloc:ProcedureReturn(rloc): EndProcedure
  
  
  
  ProcedureDLL.d stdeadoubleref(*n.DOUBLE,*x.DOUBLE):rloc.d =stdeadouble(*n\d): *x\d=rloc:ProcedureReturn(rloc): EndProcedure
  ProcedureDLL.s stdneadoubleref(*n.DOUBLE,*ch.STRING):rloc.s=stdneadouble(*n\d):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure 
  ProcedureDLL.d stdsadoubleref(*n.DOUBLE,*valeur.DOUBLE):afixer.d=*valeur:rloc.d=stdsadouble(*n\d,afixer):*valeur\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.s stdnsadoubleref(*n.DOUBLE,*ch.STRING):rloc.s=stdnsadouble(*n\d):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.d stdebdoubleref(*n.DOUBLE,*res.DOUBLE):rloc.d=stdebdouble(*n\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.s stdnebdoubleref(*n.DOUBLE,*ch.STRING):rloc.s=stdnebdouble(*n\d):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.d stdsbdoubleref(*n.DOUBLE,*valeur.DOUBLE):afixer.d=*valeur:rloc.d=stdsbdouble(*n\d,*valeur\d):*valeur\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL.s stdnsbdoubleref(*n.DOUBLE,*ch.STRING):rloc.s=stdnsb(*n\d):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  
  
  ProcedureCDLL.d ceadoubleref(*n.DOUBLE,*x.DOUBLE):rloc.d =ceadouble(*n\d): *x\d=rloc:ProcedureReturn(rloc): EndProcedure
  ProcedureCDLL.s cneadoubleref(*n.DOUBLE,*ch.STRING):rloc.s=cneadouble(*n\d):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure 
  ProcedureCDLL.d csadoubleref(*n.DOUBLE,*valeur.DOUBLE):afixer.d=*valeur:rloc.d=csadouble(*n\d,afixer):*valeur\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.s cnsadoubleref(*n.DOUBLE,*ch.STRING):rloc.s=cnsadouble(*n\d):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.d cebdoubleref(*n.DOUBLE,*res.DOUBLE):rloc.d=cebdouble(*n\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.s cnebdoubleref(*n.DOUBLE,*ch.STRING):rloc.s=cnebdouble(*n\d):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.d csbdoubleref(*n.DOUBLE,*valeur.DOUBLE):afixer.d=*valeur:rloc.d=csbdouble(*n\d,*valeur\d):*valeur\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL.s cnsbdoubleref(*n.DOUBLE,*ch.STRING):rloc.s=cnsb(*n\d):*ch\s=rloc:ProcedureReturn(rloc):EndProcedure
  
  
  
  
 
  ; fonctions de nommage numriques  paramtres par rfrence
  ProcedureDLL .i stdneadrefnum(*n.INTEGER,*pos.INTEGER,*res.INTEGER):rloc.i=stdneadnum(*n\i,*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL .i stdnsadrefnum(*n.INTEGER,*pos.INTEGER,*res.INTEGER):rloc.i=stdnsadnum(*n\i,*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL .i stdnebrefnum(*n.INTEGER,*pos.INTEGER,*res.INTEGER):rloc.i=stdnebnum(*n\i,*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL .i stdnsbrefnum(*n.INTEGER,*pos.INTEGER,*res.INTEGER):rloc.i=stdnsbnum(*n\i,*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL .i stddetailrefnum(*pos.INTEGER,*res.INTEGER):rloc.i=stddetailnum(*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL .i stdtitrerefnum(*pos.INTEGER,*res.INTEGER):rloc.i=stdtitrenum(*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  
  ProcedureCDLL .i cneadrefnum(*n.INTEGER,*pos.INTEGER,*res.INTEGER):rloc.i=cneadnum(*n\i,*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL .i cnsadrefnum(*n.INTEGER,*pos.INTEGER,*res.INTEGER):rloc.i=cnsadnum(*n\i,*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL .i cnebrefnum(*n.INTEGER,*pos.INTEGER,*res.INTEGER):rloc.i=cnebnum(*n\i,*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL .i cnsbrefnum(*n.INTEGER,*pos.INTEGER,*res.INTEGER):rloc.i=cnsbnum(*n\i,*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL .i cdetailrefnum(*pos.INTEGER,*res.INTEGER):rloc.i=cdetailnum(*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL .i ctitrerefnum(*pos.INTEGER,*res.INTEGER):rloc.i=ctitrenum(*pos\i):*res\i=rloc:ProcedureReturn(rloc):EndProcedure
 
  
  
  ProcedureDLL .d stdneadoublerefnum(*n.DOUBLE,*pos.DOUBLE,*res.DOUBLE):rloc.d=stdneadoublenum(*n\d,*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL .d stdnsadoublerefnum(*n.DOUBLE,*pos.DOUBLE,*res.DOUBLE):rloc.d=stdnsadoublenum(*n\d,*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL .d stdnebdoublerefnum(*n.DOUBLE,*pos.DOUBLE,*res.DOUBLE):rloc.d=stdnebdoublenum(*n\d,*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL .d stdnsbdoublerefnum(*n.DOUBLE,*pos.DOUBLE,*res.DOUBLE):rloc.d=stdnsbdoublenum(*n\d,*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL .d stddetaildoublerefnum(*pos.DOUBLE,*res.DOUBLE):rloc.d=stddetaildoublenum(*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureDLL .d stdtitredoublerefnum(*pos.DOUBLE,*res.DOUBLE):rloc.d=stdtitredoublenum(*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  
  ProcedureCDLL .d cneadoublerefnum(*n.DOUBLE,*pos.DOUBLE,*res.DOUBLE):rloc.d=cneadoublenum(*n\d,*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL .d cnsadoublerefnum(*n.DOUBLE,*pos.DOUBLE,*res.DOUBLE):rloc.d=cnsadoublenum(*n\d,*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL .d cnebdoublerefnum(*n.DOUBLE,*pos.DOUBLE,*res.DOUBLE):rloc.d=cnebdoublenum(*n\d,*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL .d cnsbdoublerefnum(*n.DOUBLE,*pos.DOUBLE,*res.DOUBLE):rloc.d=cnsbdoublenum(*n\d,*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL .d cdetaildoublerefnum(*pos.DOUBLE,*res.DOUBLE):rloc.d=cdetaildoublenum(*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure
  ProcedureCDLL .d ctitredoublerefnum(*pos.DOUBLE,*res.DOUBLE):rloc.d=ctitredoublenum(*pos\d):*res\d=rloc:ProcedureReturn(rloc):EndProcedure

  
 ;initialisation  de l'appareil ?
 
 Port$ = "COM1"
 vitesse=2400
 chglob$=portdisponible()
 Port$=InputRequester("Choix du port de communication pour le pHmtre ","disponibles : "+chglob$,port$)
 ;Port$=InputRequester("Choix du port de communication pour le pHmtre ","disponibles : "+portdisponible(),port$);
 ;vitesse .i=Val(InputRequester("Choix de la vitesse de communication","Choix : 300,600,1200,2400,4800,9600","2400"));
 OpenSerialPort(0, Port$,vitesse, #PB_SerialPort_NoParity, 8, 2, #PB_SerialPort_NoHandshake, 1024, 1024)
 ;WriteSerialPortString(0,"CA"+Chr(13))
 CreateThread(@miseajour(), 154)

 

; IDE Options = PureBasic 5.00 (Linux - x86)
; ExecutableFormat = Shared .so
; CursorPosition = 118
; FirstLine = 113
; Folding = -------------------------------
; EnableThread
; Executable = bibdyn_CA_C320_PB_multiprocessus.so